#include <stdio.h>
#include <string.h>

#include "d88.h"

//#define STRICT_CHECK

#define D88_HEADER_SIZE (0x20 + 4 * 164)	// D88wb_̃TCY
#define D88_NAME	(0)						// fBXN̈ʒu
#define D88_PROTECT	(0x1a)					// CgveNg̗L̈ʒu (0:Ȃ 1:)
#define D88_TYPE	(0x1b)					// fBXN̎ނ̈ʒu(00H:2D 10H:2DD 20H:2HD)
#define D88_SIZE	(0x1c)					// fBXÑTCŸʒu(DWORD)
#define D88_TRACK	(0x20)					// gbNf[^e[u̐擪̈ʒu

// dwordlϐɑ
static int GetInt(unsigned char *_p)
{
	int ret;

	ret = (_p[3]<<24) + (_p[2]<<16) + (_p[1]<<8) + _p[0];

	return ret;
}

// wordlϐɑ
static int GetShort(unsigned char *_p)
{
	int ret;

	ret = (_p[1]<<8) + _p[0];

	return ret;
}

// RXgN^
D88::D88()
{
	m_fp = NULL;

	m_minrec = 1;
	m_maxrec = 16;

	m_curdisk = -1;
	m_numdisk = 0;
	m_disktype = -1;

	m_diskname[16] = '\0';
}

// fXNgN^
D88::~D88()
{
	if (m_fp) {
		fclose(m_fp);
	}
}

/**
 * t@CJă|C^Zbg
 *
 * @param _fname [in] Input file name.
 * @return true / false
 *
 */
bool D88::SetFile(char *_fname)
{
	if (_fname == NULL) {
		fclose(m_fp);			// w肪ȂƂ́AI
		m_fp = NULL;			// fBXNC[W̃t@C|C^

		m_numdisk = 0;			// fBXN
		m_curdisk = -1;			// I𒆂̃fBXNԍ(0`)
		m_disktype = -1;		// fBXN^Cv(2D/2DD/2HD)

		return true;
	}

	m_fp = fopen(_fname, "rb");	// t@CJ (rb=ǂݏoACR/LFϊȂ)

	if (m_fp == NULL) {			// JȂƂ
		return false;
	}

	int offset = 0;

	for (m_numdisk = 0; m_numdisk < MAX_DISK; m_numdisk++) {	// fBXNJԂ
		int size;
		unsigned char header[D88_HEADER_SIZE];	// D88wb_̃m

		m_disk_offset[m_numdisk] = offset;	// fBXNԍƂ̃ItZbgʒuzɊi[

		fseek(m_fp, offset, SEEK_SET);		// t@C|C^ړ
		size = fread(header, 1, D88_HEADER_SIZE, m_fp);
		if (size != D88_HEADER_SIZE) {		// D88wb_̃TCYȉɂȂƂɒf
			break;
		}

		offset += GetInt(&header[D88_SIZE]);	// D88wb_̈ʒuvZ
	}

	return true;
}

/**
 * 1gbN̍ŏ/őZN^ݒ
 *
 * ݒ肵Ȃƍŏ1/ő16œ
 *
 * @param _min [in] ŏZN^
 * @param _max [in] őZN^
 *
 */
void D88::SetRecordRange(int _min, int _max)
{
	m_minrec = _min;
	m_maxrec = _max;
}

/**
 * ݑI𒆂D88̃fBXNԂ
 *
 * @return fBXN (1~)
 */
int D88::GetNumDisk() const
{
	return m_numdisk;
};

/**
 * ݑI𒆂̃fBXNԍԂ
 *
 * @return IfBXNԍ (1~)
 */
int D88::GetCurrentDisk() const
{
	return m_curdisk;
};

/**
 * w肵fBXNԍ̃fBXNJ
 *
 * @param _diskno [in] fBXNԍ
 * @return true / false
 *
 */
bool D88::SelectDisk(int _diskno)
{
	unsigned char header[D88_HEADER_SIZE];

	if (m_fp == NULL) {		// D88t@CI[vĂȂƂ͏߂
		return false;
	}

	m_curdisk_offset = -1;

	m_curdisk = -1;
	m_disktype = -1;	
	m_disksize = 0;
	m_diskname[0] = '\0';

	if (_diskno > m_numdisk) {	// w肵fBXNۂ̖葽Ƃ͏߂
		return false;
	}

	m_curdisk_offset = m_disk_offset[_diskno];


	fseek(m_fp, m_curdisk_offset, SEEK_SET);	// fBXNV[N
	fread(header, 1, D88_HEADER_SIZE, m_fp);
//	      buffer,size(byte),ő吔,   stream

	for (int trk = 0; trk < 164; trk++) {		// gbNʒuzɎ荞
		m_trk[trk] = GetInt(&header[D88_TRACK + trk*4]);
	}

	m_disktype = header[D88_TYPE];				// fBXN^Cv擾
	m_disksize = GetInt(&header[D88_SIZE]);		// fBXNTCY擾
	strncpy(m_diskname, (char *)&header[D88_NAME], 16);	// fBXNϐɃRs[

	return true;
}

/**
 * fBXNԂ
 *
 * @return fBXN
 *
 */
const char *D88::GetDiskName() const
{
	return m_diskname;
}

/**
 * fBXN^CvԂ
 *
 * @return fBXN^Cv
 *
 */
int D88::GetDiskType() const
{
	return m_disktype;
}

/**
 * ReadDATA1
 * gbNw肵1ZN^ǂݍ
 *
 * @param _trk [in] Track number.
 * @param _C [in] Cyrinder
 * @param _H [in] Head
 * @param _N [in] Num of sector.
 * @parma _buffer [out] Buffer pointer.
 * @param _size [in] Buffer size.
 * @return Read size.
 *
 */
int D88::ReadDATA1(int _trk, int _C, int _H, int _R, int _N, unsigned char *_buffer, int _size)
{
	if (m_fp == NULL) {		// t@CJĂȂꍇ͖߂
		return 0;
	}

	if (_trk >= 164 || m_trk[_trk] == 0 || m_trk[_trk] > m_disksize) {
		return 0;			// gbNw肪Ƃ͖߂
	}

	fseek(m_fp, m_curdisk_offset + m_trk[_trk], SEEK_SET);	// t@CV[N

	for (int sec = 0;; sec++) {		// ZN^JԂ
		unsigned char header[16];

		fread(header, 1, 16, m_fp);	// IDǂݎ

#ifdef STRICT_CHECK
		for (int i = 0x09; i <= 0x0e; i++) {
			if (header[i] != 0) {
				return 0;
			}
		}
#endif

		int C = header[0];
		int H = header[1];
		int R = header[2];
		int N = header[3];
		int maxsec = GetShort(&header[0x04]);	// őZN^
		int size = GetShort(&header[0x0e]);		// ZN^TCY

		if (maxsec == 0) {		// ЂƂZN^܂
			break;
		}

		if (C == _C && H == _H && R == _R && N == _N) { // w肵ZN^ɓBƂ
			if (size > _size) {	// ۂ̃ZN^w肳ꂽǂݎf[^傫ꍇ
				size = _size;	// ZN^TCY܂œǂݍ
			}

			fread(_buffer, 1, size, m_fp);	// fBXNC[Wǂ_bufferɊi[

			return size;					// ۂɓǂݍ񂾃TCYԂĂ
		} else {
			fseek(m_fp, size, SEEK_CUR);	// ۂ̃ZN^܂œBĂȂ̓V[Np
		}

		if (sec == maxsec - 1) {	// ȏZN^ȂƂ͒f
			break;
		}
	}

	return 0;
}

/**
 * ReadDATA
 * w肵ʒu]obt@֎w肵TCYǂݍ
 *
 * @param _trk [in] Track number
 * @param _C [in] Cyrinder
 * @param _H [in] Head
 * @param _R [in] Record
 * @param _N [in] Num of sector
 * @param _buffer [out] Buffer pointer
 * @param _size [in] Buffer size
 * @return Read size.
 *
 */
int D88::ReadDATA(int _trk, int _C, int _H, int _R, int _N, unsigned char *_buffer, int _size)
{
	int trk = _trk;		// gbNԍ
	int C = _C;			// C
	int H = _H;			// H
	int R = _R;			// R
	int N = _N;			// N
	unsigned char *buffer = _buffer;	// ΂ӂ
	int size = 0;		// ۂɓǂݍ߂TCY

	int secsize = 0x80 << _N;	// ZN^TCYN̒lvZ N=1̂Ƃ256
	int r;

	while (size < _size) {		// w肵TCYǂނ܂ŌJԂ
		// Ō̒[̓ǂݍރoCgvZ
		if (secsize > _size - size) {
			secsize = _size - size;
		}
		// 1ZN^ǂݍ
		r = ReadDATA1(trk, C, H, R, N, buffer, secsize);
		// Ō̒[܂œǂݍ݂AۂɓǂݎTCYԂĂ
		if (r < secsize) {
			return size;
		}

		buffer += secsize;	// obt@̈ʒuXV
		size += secsize;	// ۂɓǂݍ񂾃TCYXV

		// ̃ZN^ZN^̍őgbNzĂꍇ
		if (R == m_maxrec) {
			trk++;			// ̃gbN
			if (H == 0) {
				H = 1;		// ʂ
			} else {
				H = 0;		// \ʂɂC̒l+1
				C++;
			}
			R = m_minrec;	// Rŏ̃ZN^ԍɂ킹
		} else {
			R++;			// ̃ZN^ɂ킹
		}
	}

	return size;			// ǂݍ񂾃oCgԂĂ
}

/**
 * ReadID
 * wgbNIDSēǂݍ
 *
 * @param _trk [in] Track number
 * @param _buffer [out] Buffer pointer
 * @param _size [in] Buffer size
 * @return
 *
 */
int D88::ReadID(int _trk, unsigned char *_buffer, int _size)
{
	// wȂ̂Ƃ
	if (m_fp == NULL) {
		return 0;
	}

	// w肵gbÑG[`FbN
	if (_trk >= 164 || m_trk[_trk] == 0 || m_trk[_trk] > m_disksize) {
		return 0;
	}

	// fBXÑV[N
	fseek(m_fp, m_curdisk_offset + m_trk[_trk], SEEK_SET);

	int ret = 0;

	// wTCYɂȂ܂ŌJԂ
	for (int sec = 0; sec*4 < _size; sec++) {
		unsigned char header[16];

		// IDǂݎ
		fread(header, 1, 16, m_fp);

#ifdef STRICT_CHECK
		for (int i = 0x09; i <= 0x0e; i++) {
			if (header[i] != 0) {
				return 0;
			}
		}
#endif
		// ǂݎlϐɃZbg
		int C = header[0];
		int H = header[1];
		int R = header[2];
		int N = header[3];
		int maxsec = GetShort(&header[0x04]);
		int size = GetShort(&header[0x0e]);

		// ꂼ̒lobt@ɃZbg
		_buffer[sec*4 + 0] = C;
		_buffer[sec*4 + 1] = H;
		_buffer[sec*4 + 2] = R;
		_buffer[sec*4 + 3] = N;

		// ǂݍ񂾃TCYJEg
		ret += 4;

		// ݈ʒu擾
		fseek(m_fp, size, SEEK_CUR);

		// ŏIZN^̏ꍇ͔
		if (sec == maxsec - 1) {
			break;
		}
	}

	// ǂݍ񂾃TCYԂĂ
	return ret;
}
